import Vue from 'vue'
import services from './services'
import auth from './views/auth'
import auth2 from './views/auth2'
import gstarter from '../index.js'
import '../themes/theme-chalk/index.css'


Vue.config.productionTip = false

let routes = []

let routeOne = {}
routeOne['path'] = '/auth'
routeOne['name'] = 'auth'
routeOne['component'] = auth
routes.push(routeOne)

routeOne = {}
routeOne['path'] = '/auth2'
routeOne['name'] = 'auth2'
routeOne['component'] = auth2
routes.push(routeOne)

// 注入路由
gstarter.setRoutes(routes)
// 注入请求
gstarter.setServices(services)
/**
 * 设置语言
 * @param {String} 语言类型
 * @param {Object} 语言文件
 * */ 
gstarter.setLocale('zh-CN')

Vue.use(gstarter)


