import selector from '../selector'
import { Loading } from 'element-ui';

var ak = ak || {};

/**
 * 工具函数
 * 包含：格式化事件，去首位空格等等
 */
ak.utils = {

    selector(express){

        return selector.select(null,express)
    },
    parserToDate(dateText, format) {
        if (!dateText) { //空值
            return new Date();
        }	
        //定义默认值，默认值根据当前时间生成
        var defaultVal = new Date();
        var year = defaultVal.getFullYear();
        var month = defaultVal.getMonth() + 1;
        var day = defaultVal.getDate();
        var hours = defaultVal.getHours();
        var minutes = defaultVal.getMinutes();
        var seconds = defaultVal.getSeconds();
        var milliseconds = defaultVal.getMilliseconds();
        //定义正则
        var o = [{
                reg: "y+"
            }, //年份
            {
                reg: "M+"
            }, //月份
            {
                reg: "d+"
            }, //日
            {
                reg: "H+"
            }, //小时
            {
                reg: "m+"
            }, //分
            {
                reg: "s+"
            }, //秒
            {
                reg: "S"
            } //毫秒
        ];
        //获取到年月日，时分秒，毫秒几个值在字符串中的先后位置
        var index = 1;
        for (var j = 0; j < format.length; j++) {
            var onechar = format[j];
            for (var i = 0; i < o.length; i++) {
                var onepart = o[i]
                    var onepartReg = onepart.reg;
                if (onepartReg[0] == onechar) {
                    if (!onepart.index) {
                        onepart.index = index; //获取到年月日，时分秒，毫秒几个值在字符串中的先后位置
                        index++;
                    }
                    break;
                }
            }
     
        }
        //生成匹配的正则表达式
        for (var i = 0; i < o.length; i++) {
            var onepart = o[i]
                var onepartReg = onepart.reg;
            var re = new RegExp("(" + onepartReg + ")");
            var res = re.exec(format);
            if (res) {
                var formatPart = res[0]; //匹配到的格式化字符
                var replaceVal = "([0-9]{" + formatPart.length + "})"; //不能使用/d匹配,会和日期的d冲突
                format = format.replace(formatPart, replaceVal);
            }
        }
        //保存获取到的各个部分和位置
        var dataInfo = {};
        var re = new RegExp(format);
        var res = re.exec(dateText);
        //去掉第一个匹配，记录匹配到的数据
        if (res) {
            for (var i = 1; i < res.length; i++) {
                dataInfo[i] = res[i]; //记录年月日，时分秒，毫秒几个值在字符串中的位置和对应的值
            }
        } else {
            alert(dateText + "格式不匹配" + oldformat);
        }
        if (o[0].index) //年份存在
        {
            var index = o[0].index;
            year = dataInfo[index];
        }
        if (o[1].index) //月份存在
        {
            var index = o[1].index;
            month = dataInfo[index]; 
        }
        if (o[2].index) //日存在
        {
            var index = o[2].index;
            day = dataInfo[index];
        }
        if (o[3].index) //小时存在
        {
            var index = o[3].index;
            hours = dataInfo[index];
        }
        if (o[4].index) //分存在
        {
            var index = o[4].index;
            minutes = dataInfo[index];
        }
        if (o[5].index) //秒存在
        {
            var index = o[5].index;
            seconds = dataInfo[index];
        }
        if (o[6].index) //毫秒存在
        {
            var index = o[6].index;
            milliseconds = dataInfo[index];
        }
        //月份是从0开始的
        return new Date(year, month - 1, day, hours, minutes, seconds, milliseconds);
    },
    dateFormat(fmt, date) {
      let ret;
      const opt = {
        "y+": date.getFullYear().toString(),        // 年
        "M+": (date.getMonth() + 1).toString(),     // 月
        "d+": date.getDate().toString(),            // 日
        "H+": date.getHours().toString(),           // 时
        "m+": date.getMinutes().toString(),         // 分
        "s+": date.getSeconds().toString()          // 秒
        // 有其他格式化字符需求可以继续添加，必须转化成字符串
      };
      for (let k in opt) {
        ret = new RegExp("(" + k + ")").exec(fmt);
        if (ret) {
          fmt = fmt.replace(ret[1], (ret[1].length == 1) ? (opt[k]) : (opt[k].padStart(ret[1].length, "0")))
        };
      };
      return fmt;
    },
    getUrlKey(name,url){
      return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(url) || [, ""])[1].replace(/\+/g, '%20')) || null

    },
    convert2ThumbnailUrl(url){

        var index = url.lastIndexOf(".");
        if(index > 0){
            var url2 = url.substring(0,index);
            var ext = url.substring(index);

            return url2 + "_40x40" + "." + ext;
        }else
            return url;

    },
    randomNum(minNum,maxNum){ 
        switch(arguments.length){ 
            case 1: 
                return parseInt(Math.random()*minNum+1,10); 
            break; 
            case 2: 
                return parseInt(Math.random()*(maxNum-minNum+1)+minNum,10); 
            break; 
                default: 
                    return 0; 
                break; 
        } 
    },
    guid() {
        return (((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+"-"+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+"-"+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+"-"+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+"-"+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1)));
    },
    guid2() {
      return (((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+""+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+""+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+""+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+""+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1))+((((1+Math.random())*0x10000)|0).toString(16).substring(1)));
    },
    /**
     * 是否为JSON字符串
     * @param {String}
     * @return {Boolean}
     */

    isJSON(str) {
        if (typeof str == 'string') {
            try {
                var obj = JSON.parse(str);
                if (str.indexOf('{') > -1) {
                    return true;
                } else {
                    return false;
                }
            } catch (e) {
                return false;
            }
        }
        return false;
    },
    /**
     * 去除字符串首尾两端空格
     * @param {String} str
     * @return {String}
     */
    trim(str) {
        if (str) {
            return str.replace(/(^\s*)|(\s*$)/g, '');
        } else {
            return '';
        }
    },
    /**
     * 脱敏
     * @param {String} value 脱敏的对象
     * @return {String}
     */
    desensitization: function(value) {
        if (value) {
            var valueNew = '';
            const length = value.length;
            valueNew = value
                .split('')
                .map((number, index) => {
                    // 脱敏：从倒数第五位开始向前四位脱敏
                    const indexMin = length - 8;
                    const indexMax = length - 5;

                    if (index >= indexMin && index <= indexMax) {
                        return '*';
                    } else {
                        return number;
                    }
                })
                .join('');
            return valueNew;
        } else {
            return '';
        }
    },

    /**
     * 判断是否Array对象
     * @param {Object} value 判断的对象
     * @return {Boolean}
     */
    isArray: function(value) {
        return toString.call(value) === '[object Array]';
    },

    /**
     * 判断是否日期对象
     * @param {Object} value 判断的对象
     * @return {Boolean}
     */
    isDate: function(value) {
        return toString.call(value) === '[object Date]';
    },

    /**
     * 判断是否Object对象
     * @param {Object} value 判断的对象
     * @return {Boolean}
     */
    isObject: function(value) {
        return toString.call(value) === '[object Object]';
    },

    /**
     * 判断是否为空
     * @param {Object} value 判断的对象
     * @return {Boolean}
     */
    isEmpty: function(value) {
        return value === null || value === undefined || value === '' || (this.isArray(value) && value.length === 0) || (typeof obj === 'object' && Object.keys(obj).length === 0);
    },

    /**
     * 判断是否移动电话
     * @param {Number} value 判断的值
     * @return {Boolean}
     */
    isMobilePhone: function(value) {
        value = Number.parseInt(value);
        // 1)是否非数字
        if (Number.isNaN(value)) {
            return false;
        }

        // 2)时候移动电话
        return /^1[3|4|5|7|8|9|6][0-9]\d{4,8}$/.test(value);
    },

    /**
     * 判断是否为邮箱
     * @param {String} value 判断的值
     * @return {Boolean}
     */
    isEmail: function(value) {
        return /^[a-zA-Z\-_0-9]+@[a-zA-Z0-9]+(\.[a-zA-Z0-9]+)+$/.test(value);
    },

    /**
     *设置SessionStorage的值
     * @param key：要存的键
     * @param value ：要存的值
     */
    setSessionStorage: function(key, value) {
        if (this.isObject(value) || this.isArray(value)) {
            value = this.toJsonStr(value);
        }
        sessionStorage[key] = value;
    },

    /**
     *获取SessionStorage的值
     * @param key：存的键
     */
    getSessionStorage: function(key) {
        var rs = sessionStorage[key];
        try {
            if (rs != undefined) {
                var obj = this.toJson(rs);
                rs = obj;
            }
        } catch (error) {}
        return rs;
    },

    /**
     * 清除SessionStorage的值
     * @param key：存的键
     */
    removeSessionStorage: function(key) {
        return sessionStorage.removeItem(key);
    },

    /**
     *设置LocalStorage的值
     * @param key：要存的键
     * @param value ：要存的值
     */
    setLocalStorage: function(key, value) {
        if (this.isObject(value) || this.isArray(value)) {
            value = this.toJsonStr(value);
        }
        localStorage[key] = value;
    },

    /**
     *获取LocalStorage的值
     * @param key：存的键
     */
    getLocalStorage: function(key) {
        var rs = localStorage[key];
        try {
            if (rs != undefined) {
                var obj = this.toJson(rs);
                rs = obj;
            }
        } catch (error) {}
        return rs;
    },

    /**
     * 对传入的时间值进行格式化。后台传入前台的时间有两种个是：Sql时间和.Net时间
     * @param {String|Date} sValue 传入的时间字符串
     * @param {dateFormat | bool} dateFormat  日期格式，日期格式：eg：'Y-m-d H:i:s'
     * @return {String} 2014-03-01 这种格式
     * @example
     * 1) Sql时间格式：2015-02-24T00:00:00
     * 2) .Net时间格式：/Date(1410744626000)/
     */
    getDateTimeStr: function(sValue, dateFormat) {
        if (dateFormat == undefined) {
            dateFormat = 'Y-m-d'; // 默认显示年月日
        }

        var dt;
        // 1.先解析传入的时间对象，
        if (sValue) {
            if (toString.call(sValue) !== '[object Date]') {
                // 不为Date格式，就转换为DateTime类型
                sValue = sValue + '';
                if (sValue.indexOf('T') > 0) {
                    // 1)格式：2015-02-24T00:00:00
                    var timestr = sValue.replace('T', ' ').replace(/-/g, '/'); //=> 2015/02/24 00:00:00
                    dt = new Date(timestr);
                } else if (sValue.indexOf('Date') >= 0) {
                    // 2).Net格式：/Date(1410744626000)/
                    //Convert date type that .NET can bind to DateTime
                    //var date = new Date(parseInt(sValue.substr(6)));
                    var timestr = sValue.toString().replace(/\/Date\((\d+)\)\//gi, '$1'); //
                    dt = new Date(Math.abs(timestr));
                } else {
                    dt = new Date(sValue);
                }
            } else {
                dt = sValue;
            }
        }

        // 2.转换
        // 1)转换成对象 'Y-m-d H:i:s'
        var obj = {}; //返回的对象，包含了 year(年)、month(月)、day(日)
        obj.Y = dt.getFullYear(); //年
        obj.m = dt.getMonth() + 1; //月
        obj.d = dt.getDate(); //日期
        obj.H = dt.getHours();
        obj.i = dt.getMinutes();
        obj.s = dt.getSeconds();
        //2.2单位的月、日都转换成双位
        if (obj.m < 10) {
            obj.m = '0' + obj.m;
        }
        if (obj.d < 10) {
            obj.d = '0' + obj.d;
        }
        if (obj.H < 10) {
            obj.H = '0' + obj.H;
        }
        if (obj.i < 10) {
            obj.i = '0' + obj.i;
        }
        if (obj.s < 10) {
            obj.s = '0' + obj.s;
        }
        // 3.解析
        var rs = dateFormat
            .replace('Y', obj.Y)
            .replace('m', obj.m)
            .replace('d', obj.d)
            .replace('H', obj.H)
            .replace('i', obj.i)
            .replace('s', obj.s);

        return rs;
    },

    /**
     * 把总秒数转换为时分秒
     */
    getSFM: function(seconds, dateFormat) {
        if (dateFormat == undefined) {
            dateFormat = 'H:i:s'; // 默认格式
        }
        var obj = {};
        obj.H = Number.parseInt(seconds / 3600);
        obj.i = Number.parseInt((seconds - obj.H * 3600) / 60);
        obj.s = Number.parseInt(seconds - obj.H * 3600 - obj.i * 60);
        if (obj.H < 10) {
            obj.H = '0' + obj.H;
        }
        if (obj.i < 10) {
            obj.i = '0' + obj.i;
        }
        if (obj.s < 10) {
            obj.s = '0' + obj.s;
        }

        // 3.解析
        var rs = dateFormat
            .replace('H', obj.H)
            .replace('i', obj.i)
            .replace('s', obj.s);
        return rs;
    },

    /**
     * 是否同一天
     */
    isSameDay: function(dt1, dt2) {
        if (dt1.getFullYear() == dt2.getFullYear() && dt1.getMonth() == dt2.getMonth() && dt1.getDate() == dt2.getDate()) {
            return true;
        }
        return false;
    },

    /**
     * 对象转换为json字符串
     * @param  {jsonObj} jsonObj Json对象
     * @return {jsonStr} Json字符串
     */
    toJsonStr: function(jsonObj) {
        return JSON.stringify(jsonObj);
    },

    /**
     * 讲json字符串转换为json对象
     * @param {String} jsonStr Json对象字符串
     * @return {jsonObj} Json对象
     */
    toJson: function(jsonStr) {
        return JSON.parse(jsonStr);
    },

    cloneBySerialize: function(obj){
        let b = JSON.parse(JSON.stringify(obj))
        return b
    },

    /**
     * 是否含有特殊字符
     * @param  {String} value 传入的值
     * @return {Boolean} true 含有特殊符号;false 不含有特殊符号
     */
    isHaveSpecialChar: function(value) {
        var oldLength = value.length;
        var newLength = value.replace(/[`~!@#$%^&*_+=\\{}:"<>?\[\];',.\/~！@#￥%……&*——+『』：“”《》？【】；‘’，。？ \[\]()（）]/g, '').length;
        if (newLength < oldLength) {
            return true;
        }
        return false;
    },

    /**
     * 合并数组内成员的某个对象
     * @param {Array} arr 需要合并的数组
     * @param {String} fieldName 数组成员内的指定字段
     * @param {String} split 分隔符，默认为','
     * @example
     * var arr = [{name:'tom',age:13},{name:'jack',age:13}] => (arr, 'name') => tom,jack
     */
    joinArray: function(arr, fieldName, split) {
        split = split == undefined ? ',' : split;
        var rs = arr
            .map((item) => {
                return item[fieldName];
            })
            .join(split);
        return rs;
    }
};

/**
 * http交互模块
 * 包含：ajax
 */
ak.http = {
    /**
     * 将`name` - `value`对转换为支持嵌套结构的对象数组
     *
     *     var objects = toQueryObjects('hobbies', ['reading', 'cooking', 'swimming']);
     *
     *     // objects then equals:
     *     [
     *         { name: 'hobbies', value: 'reading' },
     *         { name: 'hobbies', value: 'cooking' },
     *         { name: 'hobbies', value: 'swimming' },
     *     ];
     *
     *     var objects = toQueryObjects('dateOfBirth', {
     *         day: 3,
     *         month: 8,
     *         year: 1987,
     *         extra: {
     *             hour: 4
     *             minute: 30
     *         }
     *     }, true); // Recursive
     *
     *     // objects then equals:
     *     [
     *         { name: 'dateOfBirth[day]', value: 3 },
     *         { name: 'dateOfBirth[month]', value: 8 },
     *         { name: 'dateOfBirth[year]', value: 1987 },
     *         { name: 'dateOfBirth[extra][hour]', value: 4 },
     *         { name: 'dateOfBirth[extra][minute]', value: 30 },
     *     ];
     *
     * @param {String} name
     * @param {object | Array} value
     * @param {boolean} [recursive=false] 是否递归
     * @return {array}
     */
    toQueryObjects: function(name, value, recursive) {
        var objects = [],
            i,
            ln;

        if (ak.utils.isArray(value)) {
            for (i = 0, ln = value.length; i < ln; i++) {
                if (recursive) {
                    objects = objects.concat(toQueryObjects(name + '[' + i + ']', value[i], true));
                } else {
                    objects.push({
                        name: name,
                        value: value[i]
                    });
                }
            }
        } else if (ak.utils.isObject(value)) {
            for (i in value) {
                if (value.hasOwnProperty(i)) {
                    if (recursive) {
                        objects = objects.concat(toQueryObjects(name + '[' + i + ']', value[i], true));
                    } else {
                        objects.push({
                            name: name,
                            value: value[i]
                        });
                    }
                }
            }
        } else {
            objects.push({
                name: name,
                value: value
            });
        }

        return objects;
    },

    /**
     * 把对象转换为查询字符串
     * e.g.:
     *     toQueryString({foo: 1, bar: 2}); // returns "foo=1&bar=2"
     *     toQueryString({foo: null, bar: 2}); // returns "foo=&bar=2"
     *     toQueryString({date: new Date(2011, 0, 1)}); // returns "date=%222011-01-01T00%3A00%3A00%22"
     * @param {Object} object 需要转换的对象
     * @param {Boolean} [recursive=false] 是否递归
     * @return {String} queryString
     */
    toQueryString: function(object, recursive) {
        var paramObjects = [],
            params = [],
            i,
            j,
            ln,
            paramObject,
            value;

        for (i in object) {
            if (object.hasOwnProperty(i)) {
                paramObjects = paramObjects.concat(this.toQueryObjects(i, object[i], recursive));
            }
        }

        for (j = 0, ln = paramObjects.length; j < ln; j++) {
            paramObject = paramObjects[j];
            value = paramObject.value;

            if (ak.utils.isEmpty(value)) {
                value = '';
            } else if (ak.utils.isDate(value)) {
                value =
                    value.getFullYear() +
                    '-' +
                    Ext.String.leftPad(value.getMonth() + 1, 2, '0') +
                    '-' +
                    Ext.String.leftPad(value.getDate(), 2, '0') +
                    'T' +
                    Ext.String.leftPad(value.getHours(), 2, '0') +
                    ':' +
                    Ext.String.leftPad(value.getMinutes(), 2, '0') +
                    ':' +
                    Ext.String.leftPad(value.getSeconds(), 2, '0');
            }

            params.push(encodeURIComponent(paramObject.name) + '=' + encodeURIComponent(String(value)));
        }

        return params.join('&');
    },
    /**
     * @private
     */
    getCookieVal: function(offset) {
        var endstr = document.cookie.indexOf(';', offset);
        if (endstr == -1) {
            endstr = document.cookie.length;
        }
        return unescape(document.cookie.substring(offset, endstr));
    },

    /**
     * 获取指定key的cookie
     * @param {String} key cookie的key
     */
    getCookie: function(key) {
        var arg = key + '=',
            alen = arg.length,
            clen = document.cookie.length,
            i = 0,
            j = 0;

        while (i < clen) {
            j = i + alen;
            if (document.cookie.substring(i, j) == arg) {
                return this.getCookieVal(j);
            }
            i = document.cookie.indexOf(' ', i) + 1;
            if (i === 0) {
                break;
            }
        }
        return null;
    },

    /**
     * 设置cookie
     * @param {String} key cookie的key
     * @param {String} value cookie的value
     */
    setCookie: function(key, value) {
        var argv = arguments,
            argc = arguments.length,
            expires = argc > 2 ? argv[2] : null,
            path = argc > 3 ? argv[3] : '/',
            domain = argc > 4 ? argv[4] : null,
            secure = argc > 5 ? argv[5] : false;

        document.cookie =
            key +
            '=' +
            escape(value) +
            (expires === null ? '' : '; expires=' + expires.toGMTString()) +
            (path === null ? '' : '; path=' + path) +
            (domain === null ? '' : '; domain=' + domain) +
            (secure === true ? '; secure' : '');
    },
  getRootPath(url){

    let rootPath_rtn = ''
    let currentUrl = url ? url : window.location.href
    let index = currentUrl.indexOf('#')

    if(index >= 0 ){
      let rootPath = currentUrl.substr(0,index)
      if(!rootPath.endWith('/'))
        rootPath_rtn = rootPath + '/'
      else
        rootPath_rtn = rootPath
    }else{
      if(!currentUrl.endWith('/'))
        rootPath_rtn = currentUrl + '/'
      else
        rootPath_rtn = currentUrl
    }

    if(rootPath_rtn.indexOf('?') > 0 && rootPath_rtn.endWith('/')){
      rootPath_rtn = rootPath_rtn.substr(0,rootPath_rtn.length - 1)
    }

    return rootPath_rtn
  },
  getRouteUrl(url){

    let currentUrl = url ? url : window.location.href
    let index = currentUrl.indexOf('#')
    if(index >= 0 ){
      return currentUrl.substr(index+1)
    }else{
      return ''
    }

  },
  getRoot(url){
    let rootUrl = this.getRootPath(url)
    let index = rootUrl.indexOf('?')
    if(index >= 0)
      return rootUrl.substr(0,index)
    else
      return rootUrl
  },
  getUrlParameters(url){
    let rootUrl = this.getRootPath(url)
    let index = rootUrl.indexOf('?')
    if(index >= 0)
      return rootUrl.substr(index+1)
    else
      return ''
  },
  concatParams(url,param){

    let rootUrl = this.getRootPath(url)
    let routeUrl = this.getRouteUrl(url)

    if(rootUrl.includes('?')){
      return rootUrl + '&' + param + (ak.utils.isEmpty(routeUrl) ? '': ('#' + routeUrl))
    }else{
      return rootUrl + '?' + param + (ak.utils.isEmpty(routeUrl) ? '': ('#' + routeUrl))
    }

  },
  deleteParams(url,ref){

    let rootUrl = this.getRootPath(url)
    let routeUrl = this.getRouteUrl(url)
    let newParams = ''

    if(rootUrl.includes('?')){

      let params = this.getUrlParameters(url)
      let para = params.split('&')
      for (let i = 0; i < para.length; i++) {
        let paired = para[i].split('=')
        if (paired[0] == ref) {
          continue
        }else{
          if(paired.length > 1){
            newParams += paired[0] + '=' + paired[1] + "&"
          }else{
            newParams += paired[0]
          }
        }
      }

      if(ak.utils.isEmpty(newParams)){
        return this.getRoot(rootUrl) + (ak.utils.isEmpty(routeUrl) ? '': ('#' + routeUrl))
      }
      else{
        let remed = newParams.substr(0,newParams.length-1)
        return this.getRoot(rootUrl) + '?' + remed + (ak.utils.isEmpty(routeUrl) ? '': ('#' + routeUrl))
      }


    }else{
      return url
    }

  },
  getQueryString(name) {
    var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)")
    var r = window.location.search.substr(1).match(reg)
    if(r!=null)return  unescape(r[2]); return null
  }

};

/**
 * 消息模块
 * 包含：确认框、信息提示框
 */
ak.msg = {
    /**
     * 提示框
     * msg {string} ：信息内容
     */
    alert: function(msg,callback) {

      this.vue.prototype.$alert(msg,'消息', {
        confirmButtonText: '确定',
        callback: action => {
          if(callback) callback()
        }
      });

    },

    /**
     * 确认框
     * msg {string} ：信息内容
     * callback {function} ：点击'确定'时的回调函数。
     */
    confirm: function(msg, callback,callback2) {

      this.vue.prototype.$confirm(msg,'消息', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        if(callback) callback()
      }).catch(() => {
        if(callback2) callback2()
      });


    },

    /**
     * 显示正在加载
     * @param {String} title 显示的title
     */
    showLoading: function(title) {

    },

    /**
     * 关闭正在加载
     */
    hideLoading: function() {},

    /**
     * 自动消失的提示框
     * @param {String} msg 信息内容
     */
    toast: function(msg) {}
};


/**
 * 原型：字符串格式化
 * @param args 格式化参数值
 */
String.prototype.format = function(args) {
	var result = this;
	if (arguments.length < 1) {
		return result;
	}

	var data = arguments; // 如果模板参数是数组
	if (arguments.length == 1 && typeof (args) == "object") {
		// 如果模板参数是对象
		data = args;
    }
    
	for ( var key in data) {
		var value = data[key];
		if (undefined != value) {
			result = result.replace(new RegExp("\\{" + key + "\\}", "gm"), value);
		}
	}
	return result;
}


String.prototype.endWith=function(str){
    if(str==null||str==""||this.length==0||str.length>this.length)
      return false;
    if(this.substring(this.length-str.length)==str)
      return true;
    else
      return false;
    return true;
}
    
String.prototype.startWith=function(str){
    if(str==null||str==""||this.length==0||str.length>this.length)
      return false;
    if(this.substr(0,str.length)==str)
      return true;
    else
      return false;
    return true;
}
    
    


export default ak;
