var service = service || {};

service = {
    defined:{},
    callService(serviceId,params2 = {},sendEvent = true){

        let service = this.defined[serviceId]
        let eventName = serviceId

        if(Object.prototype.toString.call(service.need) == "[object Function]"){
          if(!service.need(params2))
            return Promise.reject().catch((e) => {})
        }

        if(Object.prototype.toString.call(service.eventName) == "[object Function]"){
          eventName = service.eventName()
        }

        let params = service.getData(params2)

        return service.invoke(params).then((data)=>{

          if(sendEvent)
            this.bus.emit('porcessData', {data: data,serviceId:eventName})

          return Promise.resolve(data)
        })
        
    },
    callServices(serviceIds,params2 = [],sendEvent = true){

      let serviceIds2 = []
      let self = this
      let promises = []
      for(let index = 0 ; index < serviceIds.length ;index++){
        let service = this.defined[serviceIds[index]]

        if(Object.prototype.toString.call(service.need) == "[object Function]"){
          if(service.need(params2[index])){
            let params = service.getData(params2[index])
            promises.push(service.invoke(params))
            serviceIds2.push(serviceIds[index])
          }
        }else{
          let params = service.getData(params2[index])
          promises.push(service.invoke(params))
          serviceIds2.push(serviceIds[index])
        }

      }

      return Promise.all(promises)
        .then((data) => {

          if(sendEvent){
            for(let index = 0 ; index < serviceIds2.length ;index++){
              this.bus.emit('porcessData', {data: data[index],serviceId:serviceIds2[index]})
            }
          }

          return Promise.resolve(data)
        })

    },
    saveInitService(serviceId,data){
      let returnData = JSON.stringify(data)
      localStorage.setItem('service.initServiceId',serviceId)
      localStorage.setItem('service.initServiceData',returnData)
    }
    
}
    
    


export default service;
