import http from '../assets/http.js'
import ak from '../assets/ak.js'
import session from '../session'
import config from '../assets/config.js'

var getUserInfo = {

    getData(){
        return {'system': config.sys.id}
    },

    invoke(params){

        return http.post('/api/v1/ext/auth/auth/getUserRoles',params, true).then((data)=>{
            return Promise.resolve({
              userId:data.userId,
              name:data.name,
              roles:data.roles
            })
          }
        )
    }
    
}

export default getUserInfo;
