import http from '../assets/http.js'
import ak from '../assets/ak.js'
import config from '../assets/config.js'
import {ua} from "../assets/ua";

var inits = {

    eventName(){
      return localStorage.getItem('service.initServiceId')
    },
    getData(){
      return {}
    },
    invoke(){

      let initServiceId = localStorage.getItem('service.initServiceId')
      if(ak.utils.isEmpty(initServiceId)){

        localStorage.removeItem('service.initServiceId')
        localStorage.removeItem('service.initServiceData')
        return Promise.resolve({})
      }else{


        let data = JSON.parse(localStorage.getItem('service.initServiceData'))
        localStorage.removeItem('service.initServiceId')
        localStorage.removeItem('service.initServiceData')
        return Promise.resolve(data)
      }

    }
    
}

export default inits;
